## paraview 3.14.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.3 FATAL_ERROR)

FOREACH(policy CMP0012 CMP0013 CMP0014)
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} NEW)
  ENDIF()
ENDFOREACH()

FOREACH(policy CMP0017)
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} OLD)
  ENDIF()
ENDFOREACH()

PROJECT(ParaView)
SET(ParaView_CMAKE_DIR "${ParaView_SOURCE_DIR}/CMake")
SET (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ParaView_CMAKE_DIR})

INCLUDE(Utilities/Git/Git.cmake)

IF(CMAKE_CROSSCOMPILING)
  FIND_PACKAGE(ParaView3CompileTools REQUIRED)
ENDIF(CMAKE_CROSSCOMPILING)

SET(EXPORT_EXECUTABLES_FILE "${CMAKE_BINARY_DIR}/ParaView3CompileToolsConfig.cmake")
SET(EXPORT_EXECUTABLES_NAMESPACE "")
FILE(WRITE "${EXPORT_EXECUTABLES_FILE}" "#generated by Paraview, do not edit\n")
ADD_CUSTOM_TARGET(pvHostTools)
SET(COMPILE_TOOLS_TARGET pvHostTools)

GET_PROPERTY(PV_TARGET_SUPPORTS_SHARED_LIBS
  GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)

#########################################################################
# PARAVIEW_PLUGINLIST is used to generate the config file distributed with
# ParaView that lists the plugins distributed with ParaView.
SET(PARAVIEW_PLUGINLIST "" CACHE INTERNAL "List of configured plugins" FORCE)

#########################################################################
# Warn about ParaQ
SET(PARAVIEW_WARN_ABOUT_PARAQ)
IF(EXISTS "${ParaView_SOURCE_DIR}/CVS/Root")
  FILE(READ "${ParaView_SOURCE_DIR}/CVS/Root" paraview_cvs_root)
  IF("${paraview_cvs_root}" MATCHES ParaQ)
    SET(PARAVIEW_WARN_ABOUT_PARAQ 1)
  ENDIF("${paraview_cvs_root}" MATCHES ParaQ)
ENDIF(EXISTS "${ParaView_SOURCE_DIR}/CVS/Root")
IF("${ParaView_SOURCE_DIR}" MATCHES "ParaQ")
  SET(PARAVIEW_WARN_ABOUT_PARAQ 1)
ENDIF("${ParaView_SOURCE_DIR}" MATCHES "ParaQ")
IF(PARAVIEW_WARN_ABOUT_PARAQ)
  MESSAGE(SEND_ERROR "ParaView 3 should be checked out from ParaView3 repository. ParaQ repository is deprecated and will be removed")
ENDIF(PARAVIEW_WARN_ABOUT_PARAQ)

#########################################################################
# Disallow in-source build
IF("${ParaView_SOURCE_DIR}"  STREQUAL "${ParaView_BINARY_DIR}")
  MESSAGE(FATAL_ERROR "ParaView requires an out of source Build. Please create a separate binary directory and run CMake there.")
ENDIF("${ParaView_SOURCE_DIR}"  STREQUAL "${ParaView_BINARY_DIR}")

#########################################################################
SET (PARAVIEW_VERSION_MAJOR 3)
SET (PARAVIEW_VERSION_MINOR 14)
SET (PARAVIEW_VERSION_PATCH 1)
SET (PARAVIEW_VERSION_PATCH_EXTRA)
SET (PARAVIEW_VERSION "3.14")
SET (PARAVIEW_VERSION_FULL "3.14.1")

INCLUDE(ParaViewDetermineVersion)
determine_version(
  ${ParaView_SOURCE_DIR}
  ${GIT_EXECUTABLE}
  ${ParaView_SOURCE_DIR}/CMake/.paraview.version
  "PARAVIEW")

IF (PARAVIEW_VERSION_IS_RELEASE)
  # This is a release version.  Default to not use rpath.
  SET(VTK_USE_RPATH_DEFAULT OFF)
ELSE()
  # This is a development version.  Default to use rpath.
  SET(VTK_USE_RPATH_DEFAULT ON)
ENDIF()

#########################################################################
# build VTK/Qt support
OPTION(PARAVIEW_BUILD_QT_GUI "Build ParaView Qt Client. This requires Qt." ON)
IF (PARAVIEW_BUILD_QT_GUI)
  # need to set up Qt stuff here because there are Qt dependencies before
  # CMake traverses the Qt directory (VTK/GUISupport/Qt).
  
  # set vars to build the QVTK library
  SET(VTK_USE_GUISUPPORT ON CACHE BOOL "Build VTK with GUI Support" FORCE)
  SET(VTK_USE_QT ON CACHE BOOL "Build VTK with Qt Support" FORCE)
  # ParaView requires this minimum version of Qt, and let's do it here before
  # our first call to FindQt4.cmake
  SET(QT_MIN_VERSION "4.6.0")
  SET(QT_OFFICIAL_VERSION "4.6")
  SET(QT_REQUIRED TRUE)
  FIND_PACKAGE(Qt4)
  IF(NOT QT4_FOUND)
    MESSAGE(SEND_ERROR "Qt ${QT_MIN_VERSION} or greater not found.  Please check the QT_QMAKE_EXECUTABLE variable.")
  ELSE(NOT QT4_FOUND)
    # don't go greater than supported version
    STRING(REGEX MATCH "^4\\.[6-7]\\.[0-9]+" qt_version_match "${QTVERSION}")
    IF (NOT qt_version_match)
      STRING(REGEX MATCH "^4\\.[0-4]+\\.[0-9]+" qt_version46_x_tmp "${QTVERSION}")
      IF (qt_version46_x_tmp)
        MESSAGE(SEND_ERROR "Qt ${QTVERSION} not supported.  Please use ${QT_OFFICIAL_VERSION} (you may need to clean your dirtied cache).")
      ELSE (qt_version46_x_tmp)
        MESSAGE(WARNING "Warning: You are using Qt ${QTVERSION}. Officially supported version is Qt ${QT_OFFICIAL_VERSION}")
      ENDIF (qt_version46_x_tmp)
    ENDIF (NOT qt_version_match)
  ENDIF(NOT QT4_FOUND)
ELSE (PARAVIEW_BUILD_QT_GUI)
  SET(VTK_USE_QT OFF CACHE BOOL "Build VTK with Qt Support" FORCE)
ENDIF (PARAVIEW_BUILD_QT_GUI)
# Mark these Qt variables as advanced. Users don't really have to set them.
MARK_AS_ADVANCED(VTK_USE_QT VTK_USE_QTCHARTS VTK_USE_GUISUPPORT)
MARK_AS_ADVANCED(QT_MKSPECS_DIR QT_PLUGINS_DIR QT_X11_X11_LIBRARY QT_X11_Xext_LIBRARY QT_X11_m_LIBRARY)
# these should be all marked as advanced automatically but FindQt4 in cmake ...
MARK_AS_ADVANCED(QT_QTMOTIF_INCLUDE_DIR QT_QTMOTIF_LIBRARY_DEBUG QT_QTMOTIF_LIBRARY_RELEASE QT_HELP_GENERATOR)

# Mark certain VTK variables as advanced. Users do not really have to set these.
IF (APPLE)
  MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES CMAKE_OSX_SYSROOT VTK_USE_CARBON VTK_USE_COCOA VTK_APPLE_RESOURCE)
ENDIF(APPLE)
MARK_AS_ADVANCED(VTK_USE_MPEG2_ENCODER QT_PLUGINS_DIR QT_MKSPECS_DIR VTK_USE_MFC XDMF_BUILD_UTILS XDMF_USE_BZIP2 XDMF_USE_GZIP QT_QTDESIGNER_INCLUDE_DIR)

#########################################################################
# Define a PARAVIEW_USE_MPI that is not advanced
SET(PARAVIEW_USE_MPI OFF CACHE BOOL "Build ParaView with MPI support")
SET(VTK_USE_MPI ${PARAVIEW_USE_MPI} CACHE INTERNAL "Build VTK with MPI support" FORCE)
# define this variable so that VTK_DEPENDENT_OPTION in the VTK 
# CMakeLists.txt does not turn VTK_USE_MPI back to a regular cache
# variable
# set it to PARAVIEW_USE_MPI so that VTK_USE_MPI is slaved to it.
SET(VTK_USE_MPI_ISSET ${PARAVIEW_USE_MPI})
IF (PARAVIEW_USE_MPI)
  FIND_PACKAGE(MPI)
  SET(PARAVIEW_USE_MPI_SSEND OFF CACHE BOOL
    "Use MPI synchronous-send commands for communication")
  MARK_AS_ADVANCED(PARAVIEW_USE_MPI_SSEND)
ENDIF (PARAVIEW_USE_MPI)

#########################################################################
# Force Infovis support on
SET(VTK_USE_INFOVIS ON CACHE BOOL "Build VTK with Infovis Support" FORCE)
MARK_AS_ADVANCED(VTK_USE_INFOVIS)

#########################################################################
# Force Charts support on
SET(VTK_USE_CHARTS ON CACHE BOOL "Build VTK with Charts Support" FORCE)
MARK_AS_ADVANCED(VTK_USE_CHARTS)

#########################################################################
#
MARK_AS_ADVANCED(VTK_USE_N_WAY_ARRAYS)
MARK_AS_ADVANCED(VTK_USE_TEXT_ANALYSIS)

#########################################################################
# Configure Testing
OPTION(BUILD_TESTING "Build ParaView Testing" ON)
IF(BUILD_TESTING)
  SET(PARAVIEW_TEST_DIR    ${ParaView_BINARY_DIR}/Testing/Temporary)
  MAKE_DIRECTORY(${PARAVIEW_TEST_DIR})
  ENABLE_TESTING()
  INCLUDE (CTest)
ENDIF(BUILD_TESTING)

#########################################################################
# Configure data directory
IF(NOT PARAVIEW_DATA_ROOT AND PARAQ_DATA_ROOT)
  SET(PARAVIEW_DATA_ROOT "${PARAQ_DATA_ROOT}")
ENDIF(NOT PARAVIEW_DATA_ROOT AND PARAQ_DATA_ROOT)
FIND_PATH(PARAVIEW_DATA_ROOT ParaViewData.readme
  ${ParaView_SOURCE_DIR}/ParaViewData
  ${ParaView_SOURCE_DIR}/../ParaViewData
  ${ParaView_SOURCE_DIR}/ParaQData
  ${ParaView_SOURCE_DIR}/../ParaQData
  $ENV{PARAVIEW_DATA_ROOT}
  )

#########################################################################
# Configure Python
OPTION(PARAVIEW_ENABLE_PYTHON "Enable/Disable Python scripting support." OFF)

# PARAVIEW_TESTING_WITH_PYTHON must be used only when PARAVIEW_ENABLE_PYTHON 
# is ON. If PARAVIEW_ENABLE_PYTHON is OFF, PARAVIEW_TESTING_WITH_PYTHON 
# is ignored and treated as disabled.
OPTION(PARAVIEW_TESTING_WITH_PYTHON 
    "Build Python Testing support if PARAVIEW_ENABLE_PYTHON is ON"  
    ON)
MARK_AS_ADVANCED(PARAVIEW_TESTING_WITH_PYTHON)

IF (PARAVIEW_TESTING_WITH_PYTHON AND PARAVIEW_ENABLE_PYTHON)
  SET (QT_TESTING_WITH_PYTHON ON)
ELSE (PARAVIEW_TESTING_WITH_PYTHON AND PARAVIEW_ENABLE_PYTHON)
  SET (QT_TESTING_WITH_PYTHON OFF)
ENDIF (PARAVIEW_TESTING_WITH_PYTHON AND PARAVIEW_ENABLE_PYTHON)

IF (PARAVIEW_ENABLE_PYTHON AND PV_TARGET_SUPPORTS_SHARED_LIBS)
  SET(BUILD_SHARED_LIBS ON CACHE BOOL "Build ParaView using shared libraries" FORCE)
ENDIF (PARAVIEW_ENABLE_PYTHON AND PV_TARGET_SUPPORTS_SHARED_LIBS)

IF (PARAVIEW_ENABLE_PYTHON)
  SET(VTK_WRAP_PYTHON ON CACHE INTERNAL "" FORCE)
  SET(VTK_WRAP_PYTHON_EXE vtkWrapPython)
  SET(VTK_WRAP_PYTHON_INIT_EXE vtkWrapPythonInit)

  # ParaView python uses NewInterpretor API, which cannot be used with the
  # python's thread support API (PyGIL*). Hence, we disable all thread support.
  # No mutiple threads in paraview. Sorry.
  SET(VTK_NO_PYTHON_THREADS 1 CACHE INTERNAL "Build VTK with MPI support" FORCE)
ELSE (PARAVIEW_ENABLE_PYTHON)
  SET(VTK_WRAP_PYTHON OFF CACHE INTERNAL "" FORCE)
ENDIF (PARAVIEW_ENABLE_PYTHON)

#########################################################################
# Set the EncodeString executable
SET(VTK_ENCODESTRING_EXE vtkEncodeString)

#########################################################################
# Set the ServerManager test data dir,
SET(PVServerManagerTestData ${PARAVIEW_DATA_ROOT})

# Find hints file for the client/server wrapping
FIND_FILE(VTK_WRAP_HINTS hints ${ParaView_SOURCE_DIR}/VTK/Wrapping NO_CMAKE_FIND_ROOT_PATH)
MARK_AS_ADVANCED(VTK_WRAP_HINTS)

#########################################################################
# Any build configured headers should be added to this 
# variable so that they also get installed.
SET (dynamicHeaders)

#########################################################################
#
# add directories
#
#########################################################################

#########################################################################
# Include the file that most of the environment setup (except GUI)
# It also adds the VTK directories
SET(VTK_MAKE_INSTANTIATOR       "${ParaView_SOURCE_DIR}/VTK/CMake")
SET(VTKCS_CONFIG_DIR            "${ParaView_SOURCE_DIR}/Utilities/VTKClientServer/CMake")

# used in ParaViewPlugins.cmake
SET(ParaView_QT_DIR ${ParaView_SOURCE_DIR}/Qt)
SET(PARAVIEW_QT_QMAKE_EXECUTABLE ${QT_QMAKE_EXECUTABLE})

# Check that the Git submodules have been initialized correctly, and the local
# Git hooks have been installed.
INCLUDE(ParaViewCheckSourceTree)

INCLUDE(ParaViewMacros)
INCLUDE(ParaViewCommon)
INCLUDE(ParaViewPlugins)
INCLUDE(ParaViewBranding)
INCLUDE(ParaViewBrandingCPack)

#########################################################################
IF(BUILD_DOCUMENTATION)
  ADD_SUBDIRECTORY(Utilities/Doxygen)
ENDIF(BUILD_DOCUMENTATION)

# Documentation exists as a qch file. -> Don't build it if no Gui.
IF (PARAVIEW_BUILD_QT_GUI)
  ADD_SUBDIRECTORY(Documentation)
ENDIF (PARAVIEW_BUILD_QT_GUI)
#########################################################################
IF (PARAVIEW_BUILD_QT_GUI)
  ADD_SUBDIRECTORY(Qt)
ENDIF (PARAVIEW_BUILD_QT_GUI)

#########################################################################
OPTION(BUILD_EXAMPLES "Build ParaView examples." OFF)
IF (BUILD_EXAMPLES)
  ADD_SUBDIRECTORY(Examples)
ENDIF (BUILD_EXAMPLES)

#########################################################################
# Additional definitions for ParaViewConfig.cmake
SET(PARAVIEW_USE_FILE "${ParaView_SOURCE_DIR}/ParaViewUse.cmake")
SET(PARAVIEW_VTK_DIR "${ParaView_BINARY_DIR}/VTK")

#SET(PARAVIEW_CMAKE_EXTENSIONS "${ParaView_SOURCE_DIR}/CMake;${ParaView_SOURCE_DIR}/VTK/CMake")
IF("${CMAKE_CFG_INTDIR}" STREQUAL ".")
  SET(VTK_WRAP_ClientServer_EXE_CONFIG ${EXECUTABLE_OUTPUT_PATH}/vtkWrapClientServer)
ELSE("${CMAKE_CFG_INTDIR}" STREQUAL ".")

=== Applications/CMakeLists.txt ===
#########################################################################
# Setup Qt
SET(QT_REQUIRED TRUE)
FIND_PACKAGE(Qt4)

IF(QT4_FOUND)
# No warning if Qt not found.  ParaView/Qt does the warning for us

# This ensures that the Qt includes dir etc are set properly.
# We don't need to find the Qt4 package or include the use file
# in any of the SUBDIRS in this directory.
INCLUDE(${QT_USE_FILE})

#########################################################################
# Everything under Application uses VTK/ParaView ServerManager.
INCLUDE_DIRECTORIES(
  ${VTK_INCLUDE_DIR}
  ${PARAVIEW_INCLUDE_DIRS}
  ${PARAVIEW_GUI_INCLUDE_DIRS}
  )

MACRO(paraview_build_optional_application name comment subdirectory default)
  OPTION(PARAVIEW_BUILD_${name} "Build ${comment}" ${default})
  MARK_AS_ADVANCED(PARAVIEW_BUILD_${name})
  IF(PARAVIEW_BUILD_${name})
    MESSAGE(STATUS "Application: ${comment} enabled")
    ADD_SUBDIRECTORY("${subdirectory}")
  ELSE(PARAVIEW_BUILD_${name})
    MESSAGE(STATUS "Application: ${comment} disabled")
  ENDIF(PARAVIEW_BUILD_${name})
ENDMACRO(paraview_build_optional_application)

paraview_build_optional_application(ParaView "Standard ParaView Client" ParaView ON)

ENDIF(QT4_FOUND)

=== CoProcessing/CMakeLists.txt ===
PROJECT (CoProcessing)

SET(CoProcessing_VERSION_MAJOR "0")
SET(CoProcessing_VERSION_MINOR "1")
SET(CoProcessing_VERSION_PATCH "0")

IF (NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${CoProcessing_BINARY_DIR}/bin CACHE INTERNAL 
    "Output directory for coprocessing executables.")
ENDIF (NOT EXECUTABLE_OUTPUT_PATH)

IF (NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${CoProcessing_BINARY_DIR}/bin CACHE INTERNAL 
    "Output directory for coprocessing libraries.")
ENDIF (NOT LIBRARY_OUTPUT_PATH)

SET (CoProcessing_TEST_DIR "${CoProcessing_BINARY_DIR}/Testing/Temporary")

#--------------------------------------------------
# Find and Use ParaView
#--------------------------------------------------
IF (ParaView_SOURCE_DIR)
  INCLUDE_DIRECTORIES(
    ${PARAVIEW_INCLUDE_DIRS}
    ${PARAVIEW_GUI_INCLUDE_DIRS}
    ${PARAVIEW_KWSYS_INCLUDE_DIRS}
    ${VTK_INCLUDE_DIR}
  )
ELSE (ParaView_SOURCE_DIR)
  FIND_PACKAGE(ParaView REQUIRED)
  INCLUDE(${PARAVIEW_USE_FILE})
ENDIF (ParaView_SOURCE_DIR)

ADD_SUBDIRECTORY(CoProcessor)
OPTION(BUILD_COPROCESSING_ADAPTORS "Build CoProcessing Adaptors." OFF)
MARK_AS_ADVANCED(BUILD_COPROCESSING_ADAPTORS)
IF(BUILD_COPROCESSING_ADAPTORS)
  ADD_SUBDIRECTORY(Adaptors)
ENDIF (BUILD_COPROCESSING_ADAPTORS)

SET(CoProcessing_USE_FILE 
  "${CoProcessing_SOURCE_DIR}/CoProcessingUse.cmake")

SET(CoProcessing_LIBRARY_DIRS
  ${LIBRARY_OUTPUT_PATH}
  )

SET(CoProcessing_INCLUDE_DIRS
  ${CoProcessing_SOURCE_DIR}/Adaptors/FortranAdaptors
  ${CoProcessing_SOURCE_DIR}/CoProcessor
  ${CoProcessing_BINARY_DIR}/CoProcessor
  )

IF (PARAVIEW_ENABLE_PYTHON)
  SET(CoProcessing_INCLUDE_DIRS
     ${CoProcessing_INCLUDE_DIRS}
     ${CoProcessing_SOURCE_DIR}/Adaptors/PythonAdapter
     )
ENDIF (PARAVIEW_ENABLE_PYTHON)

# Save library dependencies.
EXPORT_LIBRARY_DEPENDENCIES(
  ${CoProcessing_BINARY_DIR}/CPLibraryDepends.cmake)

# Perform configuration.
CONFIGURE_FILE(${CoProcessing_SOURCE_DIR}/CoProcessingConfig.cmake.in
  ${CoProcessing_BINARY_DIR}/CoProcessingConfig.cmake @ONLY IMMEDIATE)

=== CommandLineExecutables/CMakeLists.txt ===
PROJECT(PVCommmandLineExecutables)

INCLUDE_DIRECTORIES(
  ${ParaView_BINARY_DIR}
  ${PVCommon_SOURCE_DIR}
  ${PVClientServerCore_SOURCE_DIR}
  ${PVServerImplementation_SOURCE_DIR}
  ${PVServerManager_SOURCE_DIR}
  ${VTK_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  )

SET(LIBS vtkPVServerManager)
IF(VTK_USE_MPI)
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
ENDIF(VTK_USE_MPI)

# Add main server executables.
SET(PV_EXE_LIST
   pvserver pvrenderserver pvdataserver)

FOREACH(pvexe ${PV_EXE_LIST})
  add_executable_with_forwarding(pv_exe_suffix
    ${pvexe} ${pvexe}.cxx)
  TARGET_LINK_LIBRARIES(${pvexe}${pv_exe_suffix} ${LIBS})

  # link enabled plugins if not building in shared library mode
  if(NOT BUILD_SHARED_LIBS)
    target_link_libraries(${pvexe}${pv_exe_suffix} ${PARAVIEW_PLUGINLIST})
  endif(NOT BUILD_SHARED_LIBS)

  # Install exe
  IF(NOT PV_INSTALL_NO_RUNTIME)
    INSTALL(TARGETS ${pvexe}
            DESTINATION ${PV_INSTALL_BIN_DIR}
            COMPONENT Runtime)
    IF (pv_exe_suffix)
      # Shared forwarding enabled.
      INSTALL(TARGETS ${pvexe}${pv_exe_suffix}
              DESTINATION ${PV_INSTALL_LIB_DIR}
              COMPONENT Runtime)
    ENDIF (pv_exe_suffix)
  ENDIF(NOT PV_INSTALL_NO_RUNTIME)

ENDFOREACH(pvexe)

SET(PV_TEST_USE_RANDOM_PORTS ON CACHE BOOL
  "Use random port numbers when testing client-server configurations.")

SET(PV_TEST_INIT_COMMAND "" CACHE STRING
  "Command to run before a test begins. Multiple commands are separated by ';'.")
MARK_AS_ADVANCED(PV_TEST_INIT_COMMAND)

SET(PV_TEST_CLEAN_COMMAND "" CACHE STRING
  "Command to run after a failed test to cleanup processes.  Example: \"killall -9 rsh paraview\"")
MARK_AS_ADVANCED(PV_TEST_CLEAN_COMMAND)

SET (PV_TEST_CLIENT "localhost" CACHE STRING
  "Node which serves as the client node, used to connect from the server side in reverse connection mode.")
MARK_AS_ADVANCED(PV_TEST_CLIENT)

# Add the test driver executable. This is not done in the above loop to avoid
# adding dependencies ${LIBS} since we only need vtksys for this executable.
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/vtkSMTestDriverConfig.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSMTestDriverConfig.h @ONLY ESCAPE_QUOTES)

add_executable_with_forwarding(pv_exe_suffix smTestDriver vtkSMTestDriver.cxx)
TARGET_LINK_LIBRARIES(smTestDriver${pv_exe_suffix} vtksys)

#------------------------------------------------------------------------
# Install ffmpeg, if used.
IF (VTK_USE_FFMPEG_ENCODER)
  FOREACH(fmpglib avcodec avformat avutil)
    IF (FFMPEG_${fmpglib}_LIBRARY)
      pv_install_library(${FFMPEG_${fmpglib}_LIBRARY}
        ${PV_INSTALL_LIB_DIR}
        BrandedRuntime)
    ENDIF(FFMPEG_${fmpglib}_LIBRARY)
  ENDFOREACH(fmpglib)
ENDIF (VTK_USE_FFMPEG_ENCODER)

IF (NOT PV_INSTALL_NO_RUNTIME)
  INSTALL(TARGETS smTestDriver
          DESTINATION ${PV_INSTALL_BIN_DIR}
          COMPONENT Runtime)
  IF (pv_exe_suffix)
    # Shared forwarding enabled.
    INSTALL(TARGETS smTestDriver${pv_exe_suffix} 
            DESTINATION ${PV_INSTALL_LIB_DIR}
            COMPONENT Runtime)
  ENDIF (pv_exe_suffix)
ENDIF (NOT PV_INSTALL_NO_RUNTIME)

#------------------------------------------------------------------------
# We setup the CPack scripts for packaging the server.
# This comes in handy when the Qt client is not built, or we want to package
# the server executables alone (pvpython, pvbatch as well, if python was
# enabled).
INCLUDE(ParaViewBrandingCPack)
# Install ParaView client
build_paraview_client_cpack_config_init(
    PACKAGE_NAME "ParaViewServers"
    ORGANIZATION "Kitware Inc."
    VERSION_MAJOR "${PARAVIEW_VERSION_MAJOR}"
    VERSION_MINOR "${PARAVIEW_VERSION_MINOR}"
    VERSION_PATCH "${PARAVIEW_VERSION_PATCH}"
    DESCRIPTION "ParaView is a scientific visualization tool"
    LICENSE_FILE "${ParaView_SOURCE_DIR}/License_v1.2.txt"
    DESCRIPTION_FILE "${ParaView_SOURCE_DIR}/License_v1.2.txt"
)

SET (CPACK_INSTALL_CMAKE_PROJECTS_DRAGNDROP
  ${CPACK_INSTALL_CMAKE_PROJECTS})
build_paraview_client_cpack_config()

=== Documentation/CMakeLists.txt ===
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/index.html.in"
    "${CMAKE_CURRENT_BINARY_DIR}/index.html"
    @ONLY)
    
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/about.html.in"
    "${CMAKE_CURRENT_BINARY_DIR}/about.html"
    @ONLY)

set (gui_xmls
  ${ParaView_SOURCE_DIR}/Applications/ParaView/ParaViewSources.xml
  ${ParaView_SOURCE_DIR}/Applications/ParaView/ParaViewFilters.xml
  ${ParaView_SOURCE_DIR}/Applications/ParaView/ParaViewReaders.xml
  ${ParaView_SOURCE_DIR}/Applications/ParaView/ParaViewWriters.xml)

# generate htmls from the server manager xmls.
generate_htmls_from_xmls(proxy_html_outputs
  "${PARAVIEW_SERVERMANAGER_XMLS}"
  "${gui_xmls}"
  "${CMAKE_CURRENT_BINARY_DIR}")

# this function produces a ${CMAKE_CURRENT_BINARY_DIR}/paraview.qch file.
build_help_project(paraview
  DESTINATION_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  DOCUMENTATION_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}"
  TABLE_OF_CONTENTS
    "<toc>
       <section title=\"ParaView User Manual\" ref=\"index.html\">
         <section title=\"Introduction\" ref=\"Book/Book_Chapter1.html\"/>
         <section title=\"Python Calculator\" ref=\"Book/Book_PythonCalculator.html\"/>
         <section title=\"Query Data\" ref=\"Book/Book_Chapter6.html\"/>
         <section title=\"Plugins\" ref=\"Book/Book_Chapter16.html\"/>
         <section title=\"Appendices\" ref=\"Book/Book_Chapter17.html\"/>
         <section title=\"Sources\" ref=\"Sources.html\"/>
         <section title=\"Filters\" ref=\"Filters.html\"/>
         <section title=\"Readers\" ref=\"Readers.html\"/>
         <section title=\"Writers\" ref=\"Writers.html\"/>
       </section>
     </toc>"
  FILEPATTERNS "*.html;*.css;*.png;*.jpg;Book/*.html;Book/*.css;Book/*.png;Book/*.jpg;images/*.jpg"
  DEPENDS "${proxy_html_outputs}"
  )

ADD_CUSTOM_TARGET (ParaViewOnlineHelp
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/paraview.qch)


SET(USERS_GUIDE_FILE "ParaView User's Guide ${PARAVIEW_VERSION}.pdf")
FIND_FILE(PARAVIEW_USERS_GUIDE ${USERS_GUIDE_FILE})
MARK_AS_ADVANCED(PARAVIEW_USERS_GUIDE)

IF (PARAVIEW_USERS_GUIDE AND EXISTS "${PARAVIEW_USERS_GUIDE}")
  INSTALL(
      FILES ${PARAVIEW_USERS_GUIDE}
      DESTINATION ${PV_INSTALL_DOC_DIR}
      COMPONENT Runtime)
ENDIF()

# Development
IF (NOT PV_INSTALL_NO_DEVELOPMENT)
  INSTALL(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/paraview.qch
      DESTINATION ${PV_INSTALL_DOC_DIR} 
      COMPONENT Development)
ENDIF (NOT PV_INSTALL_NO_DEVELOPMENT)

=== Examples/CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

IF(NOT ParaView_BINARY_DIR)
  if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
  endif(COMMAND cmake_policy)

  # we're building outside the ParaView tree.
  PROJECT(ParaViewExamples)
  FIND_PACKAGE(ParaView REQUIRED)
  INCLUDE(${PARAVIEW_USE_FILE})

  # -----------------------------------------------------------------------------
  # Disable deprecation warnings for standard C and STL functions in VS2005 and
  # later (no, we don't need IF(CMAKE_COMPILER_2005) ... )
  # -----------------------------------------------------------------------------
  IF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400 OR MSVC10)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS)
    ADD_DEFINITIONS(-D_SCL_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS)
  ENDIF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400 OR MSVC10)

  ADD_SUBDIRECTORY(Plugins)
  ADD_SUBDIRECTORY(CustomApplications)

ELSE(NOT ParaView_BINARY_DIR)

  # we're building inside the ParaView tree.

  # Build the examples as a separate project using a custom target.
  # Make sure it uses the same build configuration as ParaView.
  IF(CMAKE_CONFIGURATION_TYPES)
    SET(ParaViewExamples_CONFIG_TYPE -C "${CMAKE_CFG_INTDIR}")
  ELSE(CMAKE_CONFIGURATION_TYPES)
    SET(ParaViewExamples_CONFIG_TYPE)
  ENDIF(CMAKE_CONFIGURATION_TYPES)
  
  SET(PARAVIEW_TEST_COMMAND)
  IF(BUILD_TESTING)
    IF(APPLE)
      SET(PARAVIEW_TEST_COMMAND ${EXECUTABLE_OUTPUT_PATH}/paraview.app/Contents/MacOS/paraview 
                      --test-directory=${PARAVIEW_TEST_DIR})
    ELSE(APPLE)
      SET(PARAVIEW_TEST_COMMAND ${EXECUTABLE_OUTPUT_PATH}/paraview --test-directory=${PARAVIEW_TEST_DIR})
    ENDIF(APPLE)
  ENDIF(BUILD_TESTING)

  set (extra_params)

  foreach (flag CMAKE_C_FLAGS_DEBUG
                CMAKE_C_FLAGS_RELEASE
                CMAKE_C_FLAGS_MINSIZEREL
                CMAKE_C_FLAGS_RELWITHDEBINFO
                CMAKE_CXX_FLAGS_DEBUG
                CMAKE_CXX_FLAGS_RELEASE
                CMAKE_CXX_FLAGS_MINSIZEREL
                CMAKE_CXX_FLAGS_RELWITHDEBINFO)
    if (${${flag}})
      set (extra_params ${extra_params}
          -D${flag}:STRING=${${flag}})
    endif()
  endforeach()


  ADD_CUSTOM_COMMAND(
    OUTPUT ${ParaView_BINARY_DIR}/ParaViewExamples
    COMMAND ${CMAKE_CTEST_COMMAND}
    ARGS ${ParaViewExamples_CONFIG_TYPE}
         --build-and-test
         ${ParaView_SOURCE_DIR}/Examples
         ${ParaView_BINARY_DIR}/Examples/All
         --build-noclean
         --build-two-config
         --build-project ParaViewExamples
         --build-generator ${CMAKE_GENERATOR}
         --build-makeprogram ${CMAKE_MAKE_PROGRAM}
         --build-options -DParaView_DIR:PATH=${ParaView_BINARY_DIR}
                         -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
                         -DCMAKE_C_COMPILER:STRING=${CMAKE_C_COMPILER}
                         -DCMAKE_C_FLAGS:STRING=${CMAKE_C_FLAGS}
                         -DCMAKE_CXX_COMPILER:STRING=${CMAKE_CXX_COMPILER}
                         -DCMAKE_CXX_FLAGS:STRING=${CMAKE_CXX_FLAGS}
                         ${extra_params}
                         -DEXECUTABLE_OUTPUT_PATH:PATH=${EXECUTABLE_OUTPUT_PATH}
                         -DLIBRARY_OUTPUT_PATH:PATH=${LIBRARY_OUTPUT_PATH}
         )
  ADD_CUSTOM_TARGET(ParaViewExamplesTarget ALL DEPENDS
                    ${ParaView_BINARY_DIR}/ParaViewExamples)

  ADD_DEPENDENCIES(ParaViewExamplesTarget vtkPVServerManager)
  IF(PARAVIEW_BUILD_QT_GUI)
    ADD_DEPENDENCIES(ParaViewExamplesTarget pqComponents pqApplicationComponents)
  ENDIF(PARAVIEW_BUILD_QT_GUI)

ENDIF(NOT ParaView_BINARY_DIR)

=== ParaViewCore/CMakeLists.txt ===
PROJECT(ParaViewCore)

ADD_SUBDIRECTORY(Common)
ADD_SUBDIRECTORY(VTKExtensions)
ADD_SUBDIRECTORY(ClientServerCore)
ADD_SUBDIRECTORY(ServerImplementation)
ADD_SUBDIRECTORY(ServerManager)

IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Plugins/CMakeLists.txt ===
INCLUDE(${ParaView_CMAKE_DIR}/ParaViewPlugins.cmake)

# We setup the standard include directories that would be needed by all plugins
# anyways.
INCLUDE_DIRECTORIES(
  ${VTK_INCLUDE_DIR}
  ${PARAVIEW_INCLUDE_DIRS}
  ${PARAVIEW_GUI_INCLUDE_DIRS})
IF (PARAVIEW_BUILD_QT_GUI)
  INCLUDE(${QT_USE_FILE})
  INCLUDE_DIRECTORIES(
    ${VTK_INCLUDE_DIR}
    ${PARAVIEW_INCLUDE_DIRS}
    ${PARAVIEW_GUI_INCLUDE_DIRS})
ENDIF()

MACRO(paraview_build_optional_plugin name comment subdirectory default)
  OPTION(PARAVIEW_BUILD_PLUGIN_${name} "Build ${comment}" ${default})
  MARK_AS_ADVANCED(PARAVIEW_BUILD_PLUGIN_${name})
  IF(PARAVIEW_BUILD_PLUGIN_${name})
    MESSAGE(STATUS "Plugin: ${comment} enabled")
    get_filename_component(builddirectory ${subdirectory} NAME_WE)
    ADD_SUBDIRECTORY("${subdirectory}" "${CMAKE_CURRENT_BINARY_DIR}/${builddirectory}")
  ELSE(PARAVIEW_BUILD_PLUGIN_${name})
    MESSAGE(STATUS "Plugin: ${comment} disabled")
  ENDIF(PARAVIEW_BUILD_PLUGIN_${name})
ENDMACRO(paraview_build_optional_plugin)

paraview_build_optional_plugin(EyeDomeLighting "EyeDomeLighting" EyeDomeLighting OFF)
paraview_build_optional_plugin(Manta "Manta ray traced rendering" Manta OFF)
paraview_build_optional_plugin(Moments "Filters for Flux and Circulation Fields" Moments ON)
paraview_build_optional_plugin(Prism "Prism" PrismPlugins ON)
paraview_build_optional_plugin(PacMan "Testing plugin" TestPlugin  ON)
paraview_build_optional_plugin(PointSprite "Point Sprites" PointSprite ON)
IF(PARAVIEW_ENABLE_PYTHON)
  paraview_build_optional_plugin(pvblot "pvblot" pvblot ON)
ENDIF(PARAVIEW_ENABLE_PYTHON)
paraview_build_optional_plugin(SierraPlotTools "SierraPlotTools" SierraPlotTools ON)
paraview_build_optional_plugin(SLACTools "SLACTools" SLACTools ON)
paraview_build_optional_plugin(StreamingView "Streaming View" StreamingView ON)
paraview_build_optional_plugin( SurfaceLIC "SurfaceLIC" SurfaceLIC ON )
paraview_build_optional_plugin(VaporPlugin "Plugin to read NCAR VDF files" Vapor OFF)
paraview_build_optional_plugin(H5PartReader "Reader for *.h5part files" H5PartReader ON)
paraview_build_optional_plugin(AdiosReader "Reader for *.bp files based on Adios" AdiosReader OFF)
IF(PARAVIEW_BUILD_QT_GUI)
  paraview_build_optional_plugin(CoProcessingScriptGenerator "Plugin for creating python coprocessing scripts" CoProcessingScriptGenerator OFF)
  paraview_build_optional_plugin(VRPlugin "Virtual Reality Devices and Interactor styles" VR OFF)

  # We do not include VisTrails source in our repo for Licensing reasons. If the directory is manually copied into Plugins, build it.
  IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/VisTrails/CMakeLists.txt)
    paraview_build_optional_plugin(VisTrailsPlugin "VisTrailsPlugin" VisTrails ON)
  ENDIF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/VisTrails/CMakeLists.txt)
ENDIF(PARAVIEW_BUILD_QT_GUI)
paraview_build_optional_plugin(AnalyzeNIfTIReaderWriter "Reader/Writer for Analyze and NIfTI." AnalyzeNIfTIReaderWriter ON)
paraview_build_optional_plugin(ForceTime "Override time requests" ForceTime OFF)
paraview_build_optional_plugin(SQToolkit "SciberQuest SciViz Toolkit" SQToolkit OFF)
if(PARAVIEW_USE_MPI AND NOT WIN32)
  paraview_build_optional_plugin(Nektar "Nektar Reader Plugin" Nektar OFF)
endif()

#------------------------------------------------------------------------
# Build any plugins located outside of ParaView. This mechanism makes it
# possible to add a directory containing additions plugins to ParaView.
SET (PARAVIEW_EXTERNAL_PLUGINS_FILE "" CACHE FILEPATH
  "Path to a cmake file containing calls to build additional plugins external to ParaView.")

MARK_AS_ADVANCED(PARAVIEW_EXTERNAL_PLUGINS_FILE)

IF (EXISTS "${PARAVIEW_EXTERNAL_PLUGINS_FILE}")
  INCLUDE("${PARAVIEW_EXTERNAL_PLUGINS_FILE}")
ENDIF (EXISTS "${PARAVIEW_EXTERNAL_PLUGINS_FILE}")

#------------------------------------------------------------------------
# Added additional external plugins to ParaView's build process.
# Note that all external plugins added in such a way are enabled by default.
SET (PARAVIEW_EXTERNAL_PLUGIN_DIRS "" CACHE STRING
  "';' separated paths to additional plugin directories to be included in build process.")
MARK_AS_ADVANCED(PARAVIEW_EXTERNAL_PLUGIN_DIRS)
  
FOREACH (external_plugin_dir ${PARAVIEW_EXTERNAL_PLUGIN_DIRS})
  set (plugin_name)
  get_filename_component(plugin_name ${external_plugin_dir} NAME)
  paraview_build_optional_plugin(${plugin_name}
    "${plugin_name} (External Plugin)" ${external_plugin_dir} ON)
ENDFOREACH () 

write_plugins_file()
write_static_plugins_init_file()

=== Qt/CMakeLists.txt ===
PROJECT (PQGUI)

#########################################################################
# Setup Qt
FIND_PACKAGE(Qt4)

IF(QT4_FOUND)

# To make support of ParaView tractable, we only support a single version
# of Qt at one time.  If you really want to use a newer version of Qt, you
# can delete this check, but you are on your own.
# STRING(REGEX MATCH "^4\\.2\\.[0-9]+" qt_version_tmp "${QTVERSION}")
# IF (NOT qt_version_tmp)
#  MESSAGE(SEND_ERROR "Qt ${QTVERSION} not supported.  Please use Qt 4.2.")
# ENDIF (NOT qt_version_tmp)

SET (QT_USE_QTHELP TRUE)
SET (QT_USE_QTWEBKIT TRUE)
SET (QT_USE_QTUITOOLS TRUE)
SET (QT_USE_QTXML TRUE)  # uitools depends on xml
SET (QT_USE_QTNETWORK TRUE)
SET (QT_USE_QTNETWORK TRUE)
# This ensures that the Qt includes dir etc are set properly.
# We don't need to find the Qt4 package or include the use file
# in any of the SUBDIRS in this directory.
INCLUDE(${QT_USE_FILE})


#########################################################################
# Include Qt dependent code.
ADD_SUBDIRECTORY(Testing)
ADD_SUBDIRECTORY(Widgets)

# Include Qt, VTK & Server Manager dependent code.
ADD_SUBDIRECTORY(Core)

IF(PARAVIEW_ENABLE_PYTHON)
  ADD_SUBDIRECTORY(Python)
  SET (MOC_INCLUDE_DIRS
    ${MOC_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/Python
    )
ENDIF(PARAVIEW_ENABLE_PYTHON)

ADD_SUBDIRECTORY(Components)
ADD_SUBDIRECTORY(ApplicationComponents)

ENDIF(QT4_FOUND)

=== SuperBuild/CMakeLists.txt ===

#-----------------------------------------------------------------------------
cmake_minimum_required(VERSION 2.8.3)
#-----------------------------------------------------------------------------

# Important: change architecture *before* any enable_language() or project()
# calls so that it's set properly to detect 64-bit-ness...
#
if(APPLE)
  if(NOT CMAKE_OSX_DEPLOYMENT_TARGET OR "${CMAKE_OSX_DEPLOYMENT_TARGET}" STREQUAL "")
    set(CMAKE_OSX_ARCHITECTURES "x86_64" CACHE STRING "force build for 64-bit Leopard" FORCE)
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "force build for 64-bit Leopard" FORCE)
    set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE PATH "force build for 64-bit Leopard" FORCE)
  endif()

  set(pv_apple_compiler_args
    -DCMAKE_OSX_ARCHITECTURES:STRING=${CMAKE_OSX_ARCHITECTURES}
    -DCMAKE_OSX_DEPLOYMENT_TARGET:STRING=${CMAKE_OSX_DEPLOYMENT_TARGET}
    -DCMAKE_OSX_SYSROOT:PATH=${CMAKE_OSX_SYSROOT})

  if(NOT "${CMAKE_OSX_SYSROOT}" STREQUAL "")
    if(NOT EXISTS "${CMAKE_OSX_SYSROOT}")
      message(FATAL_ERROR "error: CMAKE_OSX_SYSROOT='${CMAKE_OSX_SYSROOT}' does not exist")
    endif()
  endif()

  if(APPLE)
    set(paraview_osx_flags "-arch x86_64 -mmacosx-version-min=@CMAKE_OSX_DEPLOYMENT_TARGET@ -isysroot @CMAKE_OSX_SYSROOT@")
  endif()
endif()

project(ParaViewSuperBuild)

set(ParaViewSuperBuild_CMAKE_SOURCE_DIR ${ParaViewSuperBuild_SOURCE_DIR})
set(ParaViewSuperBuild_CMAKE_BINARY_DIR ${ParaViewSuperBuild_BINARY_DIR}/CMake)

#------------------------------------------------------------------------------
# Update CMake module path
#------------------------------------------------------------------------------

set(CMAKE_MODULE_PATH
  ${ParaViewSuperBuild_CMAKE_SOURCE_DIR}
  ${ParaViewSuperBuild_CMAKE_BINARY_DIR}
  ${CMAKE_MODULE_PATH}
  )

#-----------------------------------------------------------------------------
# Enable and setup External project global properties
#-----------------------------------------------------------------------------

include(ExternalProject)

#-----------------------------------------------------------------------------
# Git protocol option
#-----------------------------------------------------------------------------

option(GIT_USE_GIT_PROTOCOL "If behind a firewall turn this off to use http instead." ON)
set(ENABLE_YT OFF CACHE BOOL "Install yt for astrophysics analysis")

set(git_protocol "git")
if(NOT Slicer_USE_GIT_PROTOCOL)
  set(git_protocol "http")
endif()

#-----------------------------------------------------------------------------
# Qt - Let's check if a valid version of Qt is available
#-----------------------------------------------------------------------------

FIND_PACKAGE(Qt4)
if(QT_FOUND)
  #IF("${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}" VERSION_LESS "${minimum_required_qt_version}")
  #  message(FATAL_ERROR "error: Slicer requires Qt >= ${minimum_required_qt_version} -- you cannot use Qt ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}.")
  #ENDIF()
else()
  #message(FATAL_ERROR "error: Qt4 was not found on your system. Please set QT_QMAKE_EXECUTABLE")
endif()

# ----------------------------------------------------------------------------
# generic compiler args (compiler and cflags) to pass to subprojects
#-----------------------------------------------------------------------------

set(pv_compiler_args
  -DCMAKE_CXX_COMPILER:FILEPATH=${CMAKE_CXX_COMPILER}
  -DCMAKE_C_COMPILER:FILEPATH=${CMAKE_C_COMPILER}
  -DCMAKE_CXX_FLAGS_DEBUG:STRING=${CMAKE_CXX_FLAGS_DEBUG}
  -DCMAKE_CXX_FLAGS_MINSIZEREL:STRING=${CMAKE_CXX_FLAGS_MINSIZEREL}
  -DCMAKE_CXX_FLAGS_RELEASE:STRING=${CMAKE_CXX_FLAGS_RELEASE}
  -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING=${CMAKE_CXX_FLAGS_RELWITHDEBINFO}
  -DCMAKE_C_FLAGS_DEBUG:STRING=${CMAKE_C_FLAGS_DEBUG}
  -DCMAKE_C_FLAGS_MINSIZEREL:STRING=${CMAKE_C_FLAGS_MINSIZEREL}
  -DCMAKE_C_FLAGS_RELEASE:STRING=${CMAKE_C_FLAGS_RELEASE}
  -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING=${CMAKE_C_FLAGS_RELWITHDEBINFO}
  -DCMAKE_EXE_LINKER_FLAGS:STRING=${CMAKE_EXE_LINKER_FLAGS}
  -DCMAKE_SHARED_LINKER_FLAGS:STRING=${CMAKE_SHARED_LINKER_FLAGS}
)

set(pv_tpl_cxx_flags ${CMAKE_CXX_FLAGS})
set(pv_tpl_c_flags ${CMAKE_C_FLAGS})


#if(WIN32 OR APPLE)
  set(pv_cxx_flags ${CMAKE_CXX_FLAGS})
  set(pv_c_flags ${CMAKE_C_FLAGS})
#elseif()
#  set(pv_cxx_flags "${CMAKE_CXX_FLAGS} -L${ParaViewSuperBuild_BINARY_DIR}/lib -I${ParaViewSuperBuild_BINARY_DIR}/include")
#  set(pv_c_flags "${CMAKE_C_FLAGS} -L${ParaViewSuperBuild_BINARY_DIR}/lib -I${ParaViewSuperBuild_BINARY_DIR}/include")
#endif()

if(WIN32)
  list(APPEND pv_compiler_args -DCMAKE_BUILD_TYPE:STRING=${CMAKE_CFG_INTDIR})
else()
  list(APPEND pv_compiler_args -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE})
endif()

if(APPLE)
  list(APPEND pv_compiler_args ${pv_apple_compiler_args})
endif()

# We aren't interested in seeing third party compiler warnings.
set(pv_tpl_compiler_args ${pv_compiler_args})
string(REPLACE " /W3" "" pv_tpl_cxx_flags "${pv_tpl_cxx_flags}")
string(REPLACE " /W4" "" pv_tpl_cxx_flags "${pv_tpl_cxx_flags}")
string(REPLACE " /W3" "" pv_tpl_c_flags "${pv_tpl_c_flags}")
string(REPLACE " /W4" "" pv_tpl_c_flags "${pv_tpl_c_flags}")

if(WIN32)
  set(pv_tpl_c_flags "/w ${pv_tpl_c_flags}")
  set(pv_tpl_cxx_flags "/w ${pv_tpl_cxx_flags}")
else()
  set(pv_tpl_c_flags "-w ${pv_tpl_c_flags}")
  set(pv_tpl_cxx_flags "-w ${pv_tpl_cxx_flags}")
endif()

if(WIN32)
  set(_LINK_LIBRARY_SUFFIX .lib)
elseif(APPLE)
  set(_LINK_LIBRARY_SUFFIX .dylib)
else()
  set(_LINK_LIBRARY_SUFFIX .so)
endif()

# Attempt to detect if we have a Fortran Compiler available.
include(CheckFortran)

if(CMAKE_Fortran_COMPILER)
  enable_language(Fortran)
endif()

#------------------------------------------------------------------------------
configure_file(${ParaViewSuperBuild_SOURCE_DIR}/CTestCustom.ctest.in
  ${ParaViewSuperBuild_BINARY_DIR}/CTestCustom.ctest @ONLY)

#------------------------------------------------------------------------------
# Configure Common environment files
#------------------------------------------------------------------------------

configure_file(${ParaViewSuperBuild_CMAKE_SOURCE_DIR}/paraview_common_environment.cmake.in
  ${ParaViewSuperBuild_CMAKE_BINARY_DIR}/paraview_common_environment.cmake @ONLY)

configure_file(${ParaViewSuperBuild_CMAKE_SOURCE_DIR}/paraview_configure_step.cmake.in
  ${ParaViewSuperBuild_CMAKE_BINARY_DIR}/paraview_configure_step.cmake @ONLY)

configure_file(${ParaViewSuperBuild_CMAKE_SOURCE_DIR}/paraview_make_step.cmake.in
  ${ParaViewSuperBuild_CMAKE_BINARY_DIR}/paraview_make_step.cmake @ONLY)

configure_file(${ParaViewSuperBuild_CMAKE_SOURCE_DIR}/paraview_install_step.cmake.in
  ${ParaViewSuperBuild_CMAKE_BINARY_DIR}/paraview_install_step.cmake @ONLY)

#------------------------------------------------------------------------------
# Establish Target Dependencies based on Selected Options
#------------------------------------------------------------------------------

include(PackageVersions)

set(python_dependencies)
set(CLAPACK_dependencies)
set(NUMPY_dependencies)
set(MPL_dependencies)
set(Cython_dependencies)
set(h5py_dependencies)
set(Manta_dependencies)
set(OpenMPI_dependencies)
set(ParaView_dependencies)

set(PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS)
set(PARAVIEW_EXTERNAL_PLUGIN_DIRS)
set(MPI_ARGS)

# Build a common zlib used by several dependencies
include(External_zlib)
set(ZLIB_ARGS
   -DVTK_USE_SYSTEM_ZLIB:BOOL=ON
   -DZLIB_INCLUDE_DIR:PATH=${ZLIB_INCLUDE_DIR}
   -DZLIB_LIBRARY:FILEPATH=${ZLIB_LIBRARY})
list(APPEND ParaView_dependencies zlib)
list(APPEND png_dependencies zlib)
list(APPEND python_dependencies zlib)

# Build a common szip used by several dependencies
include(External_szip)
#set(SZIP_ARGS
#   -DVTK_USE_SYSTEM_ZLIB:BOOL=ON
#   -DZLIB_INCLUDE_DIR:PATH=${ZLIB_INCLUDE_DIR}
#   -DZLIB_LIBRARY:FILEPATH=${ZLIB_LIBRARY})

if(WIN32 OR APPLE)
  # Build a common png used by several dependencies
  include(External_png)
  # can't get paraview to build SMExtractDocumentation with externally built png
  # until then ParaView will still use the system png.
  set(PNG_ARGS
    -DVTK_USE_SYSTEM_PNG:BOOL=ON
    -DPNG_PNG_INCLUDE_DIR:PATH=${PNG_INCLUDE_DIR}
    -DPNG_LIBRARY:FILEPATH=${PNG_LIBRARY})
  list(APPEND ParaView_dependencies png)
endif()

if(WIN32)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${png_install}/bin)
else()
  get_filename_component(PNG_DIR "${PNG_LIBRARY}" PATH)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${PNG_DIR})
endif()

if(NOT APPLE)
  if(WIN32)
    include(External_OpenMPI)
    list(APPEND ParaView_dependencies OpenMPI)
  else()
    include(External_MPICH2)
    list(APPEND ParaView_dependencies MPICH2)
  endif()

  set(MPI_ARGS
    -DMPI_DIR:PATH=${MPI_INSTALL}
    -DPARAVIEW_USE_MPI:BOOL=ON
    -DMPIEXEC:FILEPATH=${MPIEXEC}
    -DMPI_C_COMPILER:FILEPATH=${MPICC}
    -DMPI_CXX_COMPILER:FILEPATH=${MPICXX}
    -DVTK_MPIRUN_EXE:FILEPATH=${MPIEXEC}
    -DMPI_INCLUDE_PATH:PATH=${MPI_INCLUDE_PATH}
    -DMPI_LIBRARY:FILEPATH=${MPI_LIBRARY}
    -DMPI_EXTRA_LIBRARY:FILEPATH=${MPI_EXTRA_LIBRARY}
    -DPARAVIEW_INSTALL_MPIEXEC:BOOL=ON)

  include(External_Python)
  list(APPEND ParaView_depenencies Python)

  set(NUMPY_dependencies python)

  if(CMAKE_Fortran_COMPILER AND NOT WIN32)
    include(External_LAPACK)
    list(APPEND NUMPY_dependencies LAPACK)
    list(APPEND ParaView_dependencies LAPACK)
  else()
    include(External_CLAPACK)
    list(APPEND NUMPY_dependencies CLAPACK)
    list(APPEND ParaView_dependencies CLAPACK)
  endif()

  include(External_NUMPY)
else()

  find_package(PythonInterp)
  find_package(PythonLibs)

  if(APPLE AND "${CMAKE_OSX_DEPLOYMENT_TARGET}" STREQUAL "10.5")
    set(PYTHON_EXECUTABLE "/System/Library/Frameworks/Python.framework/Versions/2.5/bin/python" CACHE FILEPATH "" FORCE)
    set(PYTHON_LIBRARY "/System/Library/Frameworks/Python.framework/Versions/2.5/Python" CACHE PATH "" FORCE)
    set(PYTHON_INCLUDE_DIR "/System/Library/Frameworks/Python.framework/Versions/2.5/include/python2.5" CACHE FILEPATH "" FORCE)
  endif()

  #find_package(MPI)
  #set(MPI_ARGS
  #  -DPARAVIEW_USE_MPI:BOOL=OFF
  #  -DMPI_DIR:PATH=${MPI_INSTALL}
  #  -DMPIEXEC:FILEPATH=${MPIEXEC}
  #  -DVTK_MPIRUN_EXE:FILEPATH=${MPIEXEC}
  #  -DMPI_INCLUDE_PATH:PATH=${MPI_INCLUDE_PATH}
  #  -DMPI_LIBRARY:FILEPATH=${MPI_LIBRARY}
  #  -DMPI_EXTRA_LIBRARY:FILEPATH=${MPI_EXTRA_LIBRARY}
  #  -DPARAVIEW_INSTALL_MPIEXEC:BOOL=ON)

  include(External_NUMPY)
endif()

set(MANTA_ARGS)
# Manta doesn't compile on Windows x64 currently
#if(NOT (WIN32 AND "${CMAKE_SIZEOF_VOID_P}" EQUAL 8))
if(NOT WIN32)
  include(External_Manta)
  set(MANTA_ARGS
    -DPARAVIEW_BUILD_PLUGIN_Manta:BOOL=ON
    -DMANTA_BUILD:PATH=${Manta_binary}
    -DMANTA_SOURCE:PATH=${Manta_source})
  list(APPEND ParaView_dependencies Manta)
endif()

include(External_Boost)
list(APPEND ParaView_dependencies Boost)

if(WIN32)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${zlib_install}/bin)
else()
  get_filename_component(ZLIB_DIR "${ZLIB_LIBRARY}" PATH)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${ZLIB_DIR})
endif()

# Build HDF5
list(APPEND HDF5_dependencies zlib szip)
list(APPEND ParaView_dependencies HDF5)
include(External_HDF5)
set(HDF5_ARGS
  -DVTK_USE_SYSTEM_HDF5:BOOL=ON
  -DHDF5_DIR:PATH=${HDF5_install}
  -DHDF5_FOUND:BOOL=ON
  -DHDF5_INCLUDE_DIRS:PATH=${HDF5_INCLUDE_DIR}
  -DHDF5_INCLUDE_DIR:PATH=${HDF5_INCLUDE_DIR}
  -DHDF5_LIBRARIES:FILEPATH=${HDF5_LIBRARY};${HDF5_HL_LIBRARY}
  -DHDF5_LIBRARY:FILEPATH=${HDF5_LIBRARY}
  -DHDF5_HL_LIBRARY:FILEPATH=${HDF5_HL_LIBRARY}
  -DHDF5_hdf5_LIBRARY:FILEPATH=${HDF5_LIBRARY}
  -DHDF5_hdf5_LIBRARY_RELEASE:FILEPATH=${HDF5_LIBRARY}
  -DHDF5_hdf5_hl_LIBRARY:FILEPATH=${HDF5_HL_LIBRARY}
  -DHDF5_hdf5_hl_LIBRARY_RELEASE:FILEPATH=${HDF5_HL_LIBRARY})

if(WIN32)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${HDF5_install}/bin)
else()
  get_filename_component(HDF5_DIR "${HDF5_LIBRARY}" PATH)
  list(APPEND PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${HDF5_DIR})
endif()

=== VTK/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.3 FATAL_ERROR)

FOREACH(policy CMP0012 CMP0013 CMP0014)
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} NEW)
  ENDIF()
ENDFOREACH()

FOREACH(policy CMP0017)
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} OLD)
  ENDIF()
ENDFOREACH()

PROJECT(VTK)

# Objective C compile flags, future CMake versions might make this obsolete
IF(APPLE)
  STRING(REGEX REPLACE "^.*MacOSX([0-9]*\\.[0-9]*)\\.sdk$" "\\1"
         OSX_SDK_VERSION "${CMAKE_OSX_SYSROOT}")
  SET(VTK_OBJCXX_FLAGS_DEFAULT)
  IF(OSX_SDK_VERSION)
    IF(${OSX_SDK_VERSION} VERSION_GREATER "10.4")
      SET(VTK_OBJCXX_FLAGS_DEFAULT "-fobjc-gc")
    ENDIF(${OSX_SDK_VERSION} VERSION_GREATER "10.4")
  ENDIF(OSX_SDK_VERSION)
  SET(VTK_REQUIRED_OBJCXX_FLAGS ${VTK_OBJCXX_FLAGS_DEFAULT} CACHE STRING "Extra flags for Objective C compilation")
  MARK_AS_ADVANCED(VTK_REQUIRED_OBJCXX_FLAGS)
ENDIF(APPLE)

# The Cygwin maintainers have requested that we not define WIN32. Thus developers
# must use the X11 packages to build cygwin vtk.
IF(CYGWIN)
  unset(WIN32)
ENDIF()

# the following lines are for cross compiling support
# we may get here also from ParaView, in this case don't change the filename
IF(NOT EXPORT_EXECUTABLES_FILE)
  # the generators which are needed during the build have to be imported
  # from a native build, which exports them, requires cmake cvs or 2.6
  IF(CMAKE_CROSSCOMPILING)
    FIND_PACKAGE(VTKCompileTools REQUIRED)
  ENDIF(CMAKE_CROSSCOMPILING)

  SET(EXPORT_EXECUTABLES_FILE "${CMAKE_BINARY_DIR}/VTKCompileToolsConfig.cmake")
  SET(EXPORT_EXECUTABLES_NAMESPACE "")
  FILE(WRITE "${EXPORT_EXECUTABLES_FILE}" "#generated by VTK, do not edit\n")
ENDIF(NOT EXPORT_EXECUTABLES_FILE)

GET_PROPERTY(VTK_TARGET_SUPPORTS_SHARED_LIBS
  GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)

# Warn when using "old style" CMake install commands... But only when
# building VTK itself.
#
IF("${VTK_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  MACRO(INSTALL_TARGETS)
    MESSAGE(FATAL_ERROR "Somebody is calling old INSTALL_TARGETS command with arguments: ${ARGV}")
  ENDMACRO(INSTALL_TARGETS)
  MACRO(INSTALL_PROGRAMS)
    MESSAGE(FATAL_ERROR "Somebody is calling old INSTALL_PROGRAMS command with arguments: ${ARGV}")
  ENDMACRO(INSTALL_PROGRAMS)
  MACRO(INSTALL_FILES)
    MESSAGE(FATAL_ERROR "Somebody is calling old INSTALL_FILES command with arguments: ${ARGV}")
  ENDMACRO(INSTALL_FILES)
ENDIF("${VTK_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

SET(VTK_CMAKE_DIR "${VTK_SOURCE_DIR}/CMake")
SET(CMAKE_MODULE_PATH "${VTK_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

# Add supplemental compiler warnings, and GCC visibility support.
INCLUDE(vtkCompilerExtras)

# Check the source tree - right now just for local Git hooks.
INCLUDE(vtkCheckSourceTree)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

#-----------------------------------------------------------------------------
# VTK version number.  An even minor number corresponds to releases.
SET(VTK_MAJOR_VERSION 5)
SET(VTK_MINOR_VERSION 9)
SET(VTK_BUILD_VERSION 0)
SET(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")

# Append the library version information to the library target
# properties.  A parent project may set its own properties and/or may
# block this.
IF(NOT VTK_NO_LIBRARY_VERSION)
  SET(VTK_LIBRARY_PROPERTIES ${VTK_LIBRARY_PROPERTIES}
    VERSION "${VTK_VERSION}"
    SOVERSION "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}"
    )
ENDIF(NOT VTK_NO_LIBRARY_VERSION)

INCLUDE(vtkTargetExportMacros)

#-----------------------------------------------------------------------------
# Determine whether we are being built by CTest and if so the version.
# For CTest 2.2 and higher this will contain the version number.  For
# earlier CTest versions this will contain just "1".  If not
# configuring from CTest this should be empty, so set the result to a
# literal "0" (helps with numerical comparisons).
SET(VTK_TEST_FROM_CTEST "$ENV{DASHBOARD_TEST_FROM_CTEST}")
IF(NOT VTK_TEST_FROM_CTEST)
  SET(VTK_TEST_FROM_CTEST 0)
ENDIF(NOT VTK_TEST_FROM_CTEST)

# Determine whether tests requiring the configuration type to be known
# can be run.  Start by assuming the configuration type is known.
# This is the case when using a generator supporting only one
# configuration type.
SET(VTK_TEST_CONFIG_TYPE_KNOWN 1)
IF(CMAKE_CONFIGURATION_TYPES)
  # When there are multiple configuration types we must be running
  # tests with a CTest that knows how to give the configuration type
  # to the test when it runs.  This requires CTest 2.2 or higher.
  IF(VTK_TEST_FROM_CTEST LESS "2.2")
    # This is either a CTest older than 2.2 or not a CTest.
    # The configuration type will not be known when running the tests.
    SET(VTK_TEST_CONFIG_TYPE_KNOWN 0)
  ENDIF(VTK_TEST_FROM_CTEST LESS "2.2")
ENDIF(CMAKE_CONFIGURATION_TYPES)

#-----------------------------------------------------------------------------
# Load some macros.
INCLUDE(vtkDependentOption)
INCLUDE(vtkThirdParty)
INCLUDE(vtkExportKit)
INCLUDE(vtkMakeInstantiator)
INCLUDE(CMakeExportBuildSettings)

#-----------------------------------------------------------------------------
# Choose static or shared libraries.
INCLUDE(vtkSelectSharedLibraries)

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
INCLUDE(CheckCXXSourceRuns)
FILE(READ "${VTK_CMAKE_DIR}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
CHECK_CXX_SOURCE_RUNS("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"
  CMAKE_REQUIRE_LARGE_FILE_SUPPORT "Support for 64 bit file systems")
SET(VTK_REQUIRE_LARGE_FILE_SUPPORT ${CMAKE_REQUIRE_LARGE_FILE_SUPPORT})

#-----------------------------------------------------------------------------
# Does the const_reverse_iterator have the comparison operators? Before GCC
# 4.1 they were not present.
INCLUDE(CheckCXXSourceCompiles)
SET(VTK_CONST_REVERSE_ITERATOR_COMPARISON_FILE
"#include <vector>
int main()
{
  std::vector<int> test;
  std::vector<int>::const_reverse_iterator it = test.rbegin();
  it != test.rend();
  return 0;
}")
CHECK_CXX_SOURCE_COMPILES("${VTK_CONST_REVERSE_ITERATOR_COMPARISON_FILE}"
  VTK_CONST_REVERSE_ITERATOR_COMPARISON)

#-----------------------------------------------------------------------------
# Discover the name of the runtime library path environment variable
# and put the result in SHARED_LIBRARY_PATH_VAR_NAME.
# The result depends on the platform and on some platforms it depends on
# the compiler options (32-bit vs. 64-bit).

INCLUDE(SharedLibraryPathVarName)

#-----------------------------------------------------------------------------
# Output directories.
IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${VTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${VTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

#-----------------------------------------------------------------------------
# Directories with the configuration subdir, for advanced use only.
# These are only used when passing arguments to custom commands,
# or when writing config files for use by external projects.
# In other circumstances, the build system will handle the config
# subdirectory automatically.

IF("${CMAKE_CFG_INTDIR}" STREQUAL ".")
  SET(VTK_LIBRARY_DIR ${LIBRARY_OUTPUT_PATH})
  SET(VTK_EXECUTABLE_DIR ${EXECUTABLE_OUTPUT_PATH})
ELSE("${CMAKE_CFG_INTDIR}" STREQUAL ".")
  SET(VTK_LIBRARY_DIR ${LIBRARY_OUTPUT_PATH}/${CMAKE_CFG_INTDIR})
  SET(VTK_EXECUTABLE_DIR ${EXECUTABLE_OUTPUT_PATH}/${CMAKE_CFG_INTDIR})
ENDIF("${CMAKE_CFG_INTDIR}" STREQUAL ".")

#-----------------------------------------------------------------------------
# Where the cxx tests are, for use in ADD_TEST
SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})
IF(CMAKE_CONFIGURATION_TYPES)
  SET(CXX_TEST_CONFIG /\${CTEST_CONFIGURATION_TYPE})
ELSE()
  SET(CXX_TEST_CONFIG "")
ENDIF()

#-----------------------------------------------------------------------------
# Configure install locations.  This allows parent projects to modify
# the install location.  Optionally allow the project to specify a
# single VTK_INSTALL_ROOT which basically adds to its install prefix
# for VTK only.

# The location in which to install VTK executables.
IF(NOT VTK_INSTALL_BIN_DIR)
  SET(VTK_INSTALL_BIN_DIR ${VTK_INSTALL_ROOT}/bin)
ENDIF(NOT VTK_INSTALL_BIN_DIR)

# The location in which to install VTK header files.
IF(NOT VTK_INSTALL_INCLUDE_DIR)
  SET(VTK_INSTALL_INCLUDE_DIR
    ${VTK_INSTALL_ROOT}/include/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}
    )
ENDIF(NOT VTK_INSTALL_INCLUDE_DIR)

# The location in which to install VTK libraries.
IF(NOT VTK_INSTALL_LIB_DIR)
  SET(VTK_INSTALL_LIB_DIR
    ${VTK_INSTALL_ROOT}/lib/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}
    )
ENDIF(NOT VTK_INSTALL_LIB_DIR)

# The location in which to install misc VTK files
IF(NOT VTK_INSTALL_SHARE_DIR)
  SET(VTK_INSTALL_SHARE_DIR
    ${VTK_INSTALL_ROOT}/share/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}
    )
ENDIF(NOT VTK_INSTALL_SHARE_DIR)

# The location in which to install CMake scripts for packaging VTK.
IF(NOT VTK_INSTALL_PACKAGE_DIR)
  SET(VTK_INSTALL_PACKAGE_DIR ${VTK_INSTALL_LIB_DIR})
ENDIF(NOT VTK_INSTALL_PACKAGE_DIR)

# The location in which to install VTK doxygen documentation helper
# files.
IF(NOT VTK_INSTALL_DOXYGEN_DIR)
  SET(VTK_INSTALL_DOXYGEN_DIR ${VTK_INSTALL_PACKAGE_DIR}/doxygen)
ENDIF(NOT VTK_INSTALL_DOXYGEN_DIR)

# The location in which to install VTK documentation files that
# are not automatically generated.
IF(NOT VTK_INSTALL_DOC_DIR)
  SET(VTK_INSTALL_DOC_DIR ${VTK_INSTALL_PACKAGE_DIR}/doc)
ENDIF(NOT VTK_INSTALL_DOC_DIR)

# Compute the proper location for installing the Tcl package.  This
# must be a fixed relative path below the library install location and
# is therefore not settable by parent projects.
SET(VTK_INSTALL_TCL_DIR ${VTK_INSTALL_LIB_DIR})

IF(NOT VTK_INSTALL_JAVA_DIR)
  SET(VTK_INSTALL_JAVA_DIR ${VTK_INSTALL_PACKAGE_DIR}/java)
ENDIF(NOT VTK_INSTALL_JAVA_DIR)

OPTION(VTK_INSTALL_THIRD_PARTY_LIBRARIES "Use fixup bundle to install vtk and vtkpython dependencies." OFF)
MARK_AS_ADVANCED(VTK_INSTALL_THIRD_PARTY_LIBRARIES)

# There are three basic components to the VTK installation: runtime,
# development, and documentation.  Install rules for each component
# are surrounded by blockers.  Parent projects or users can specify
# VTK_INSTALL_NO_RUNTIME, VTK_INSTALL_NO_DEVELOPMENT, or
# VTK_INSTALL_NO_DOCUMENTATION to avoid installation of the
# corresponding component.

# Shared libraries are considered both runtime and development and
# static libraries are considered development only.  In order to
# switch library installation on and off correctly we make the
# decision here.
SET(VTK_INSTALL_NO_LIBRARIES)

IF(BUILD_SHARED_LIBS)
  IF(VTK_INSTALL_NO_RUNTIME AND VTK_INSTALL_NO_DEVELOPMENT)
    SET(VTK_INSTALL_NO_LIBRARIES ON)
  ENDIF(VTK_INSTALL_NO_RUNTIME AND VTK_INSTALL_NO_DEVELOPMENT)
ELSE(BUILD_SHARED_LIBS)
  IF(VTK_INSTALL_NO_DEVELOPMENT)
    SET(VTK_INSTALL_NO_LIBRARIES ON)
  ENDIF(VTK_INSTALL_NO_DEVELOPMENT)
ENDIF(BUILD_SHARED_LIBS)

# Because INSTALL_* commands require a leading / and because INSTALL (cmake 2.4
# and newer) requires no leading / to install under INSTALL_PREFIX, we
# are stripping the leading /. In the future, there should be no leading
# / in any install directory variables
STRING(REGEX REPLACE "^/" "" VTK_INSTALL_LIB_DIR_CM24 "${VTK_INSTALL_LIB_DIR}")

=== Applications/ParaView/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Add extra library containing custom code for the client.
QT4_WRAP_CPP(MOC_BUILT_SOURCES
  ParaViewMainWindow.h)

QT4_WRAP_UI(UI_BUILT_SOURCES
  ParaViewMainWindow.ui
)

source_group("Generated" FILES
  ${MOC_BUILT_SOURCES}
  ${UI_BUILT_SOURCES}
)

set (QT_USE_QTNETWORK TRUE)
include(${QT_USE_FILE})

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR})

set(ParaView_SOURCE_FILES
  ParaViewMainWindow.cxx
  ParaViewMainWindow.h
  ${MOC_BUILT_SOURCES}
  ${UI_BUILT_SOURCES})

#------------------------------------------------------------------------------
# Add install rules for required system runtimes such as MSVCRxx.dll
set (CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP ON)
include(InstallRequiredSystemLibraries)
if (CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS)
  install(FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}
    DESTINATION ${PV_INSTALL_BIN_DIR}
    PERMISSIONS OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ
    COMPONENT Runtime)

  # Install the runtimes to the lib dir as well since python modules are
  # installed in that directory and the manifest files need to present there as
  # well.
  install(FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}
    DESTINATION ${PV_INSTALL_LIB_DIR}
    PERMISSIONS OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ
    COMPONENT Runtime)
endif (CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS)

#------------------------------------------------------------------------------
# Build the client
build_paraview_client(paraview
    APPLICATION_NAME "ParaView"
    TITLE "ParaView ${PARAVIEW_VERSION_FULL} ${PARAVIEW_BUILD_ARCHITECTURE}-bit"
    ORGANIZATION  "ParaView"
    VERSION_MAJOR ${PARAVIEW_VERSION_MAJOR} 
    VERSION_MINOR ${PARAVIEW_VERSION_MINOR}
    VERSION_PATCH ${PARAVIEW_VERSION_PATCH}
    SPLASH_IMAGE "${CMAKE_CURRENT_SOURCE_DIR}/PVSplashScreen.png"
    PVMAIN_WINDOW ParaViewMainWindow
    PVMAIN_WINDOW_INCLUDE ParaViewMainWindow.h
    BUNDLE_ICON   "${CMAKE_CURRENT_SOURCE_DIR}/MacIcon.icns"
    APPLICATION_ICON  "${CMAKE_CURRENT_SOURCE_DIR}/WinIcon.ico"
    GUI_CONFIGURATION_XMLS
      ${CMAKE_CURRENT_SOURCE_DIR}/ParaViewSources.xml
      ${CMAKE_CURRENT_SOURCE_DIR}/ParaViewFilters.xml
      ${CMAKE_CURRENT_SOURCE_DIR}/ParaViewReaders.xml
      ${CMAKE_CURRENT_SOURCE_DIR}/ParaViewWriters.xml
      ${PARAVIEW_EXTRA_GUI_RESOURCES} # Add any compiled in GUI configuration xmls
    COMPRESSED_HELP_FILE "${ParaView_BINARY_DIR}/Documentation/paraview.qch"
    SOURCES ${ParaView_SOURCE_FILES}
    INSTALL_BIN_DIR "${PV_INSTALL_BIN_DIR}"
    INSTALL_LIB_DIR "${PV_INSTALL_LIB_DIR}")

# link enabled plugins if not building in shared library mode
if(NOT BUILD_SHARED_LIBS)
  target_link_libraries(paraview ${PARAVIEW_PLUGINLIST})
endif(NOT BUILD_SHARED_LIBS)

# This ensure that the paraview.qch file is generated.
add_dependencies(${paraview_client_real_exe_name}
  ParaViewOnlineHelp)

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif (BUILD_TESTING)


#########################################################################
# Add install rules for installing certain dependencies.

if (PARAVIEW_INSTALL_THIRD_PARTY_LIBRARIES AND NOT APPLE)

  if(WIN32)
   set(pv_runtime_dest ${PV_INSTALL_BIN_DIR})
  else()
   set(pv_runtime_dest ${PV_INSTALL_LIB_DIR})
  endif()

  # Now install the all the plugins
  if(QT_QTSVG_FOUND AND WIN32)
    install(FILES ${QT_BINARY_DIR}/QtSvg4.dll
            DESTINATION ${pv_runtime_dest}
            PERMISSIONS OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ
            COMPONENT Runtime)
  endif()
  
  # Now install all the Qt plugins 
  #tack on the / to get all the subdirectories not the plugin directory
  install(DIRECTORY "${QT_PLUGINS_DIR}/"
          DESTINATION ${pv_runtime_dest}
          COMPONENT Runtime
          FILES_MATCHING PATTERN "*.dll")
          
  if(PARAVIEW_ENABLE_PYTHON)
    option(PARAVIEW_INSTALL_PYTHON "Install core python modules in ParaView." OFF)
    mark_as_advanced(PARAVIEW_INSTALL_PYTHON)

    if(PARAVIEW_INSTALL_PYTHON)
      if(WIN32)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(standard_lib=1)"
                        OUTPUT_VARIABLE PYTHON_LIBS_DIR
                        OUTPUT_STRIP_TRAILING_WHITESPACE)
        set(PYTHON_LIBS_DEST ${pv_runtime_dest})
      else(WIN32)
        get_filename_component(PYTHON_LIBS_DIR "${PYTHON_LIBRARY}" PATH)
        file(TO_CMAKE_PATH ${PYTHON_LIBS_DIR} PYTHON_LIBS_DIR)

        # install pyconfig.h
        string(REGEX MATCH "python[0-9].[0-9]" py_ver_dir ${PYTHON_INCLUDE_DIR})
        install(FILES ${PYTHON_INCLUDE_DIR}/pyconfig.h
                DESTINATION ${PV_INSTALL_LIB_DIR}/include/${py_ver_dir}
                PERMISSIONS OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ
                COMPONENT Runtime)
        set(PYTHON_LIBS_DIR ${PYTHON_LIBS_DIR}/${py_ver_dir})
        set(PYTHON_LIBS_DEST ${pv_runtime_dest}/lib)
        
        file(GLOB python_modules "${ParaView_BINARY_DIR}/bin/*Python.so")

        install(FILES ${python_modules}
          DESTINATION ${pv_runtime_dest}
          COMPONENT Runtime)

      endif(WIN32)
      
      file(TO_CMAKE_PATH ${PYTHON_LIBS_DIR} PYTHON_LIBS_DIR)
      install(DIRECTORY ${PYTHON_LIBS_DIR}
              DESTINATION ${PYTHON_LIBS_DEST}
              USE_SOURCE_PERMISSIONS
              COMPONENT Runtime
              REGEX "lib2to3/" EXCLUDE
              REGEX "lib[-]old/" EXCLUDE
              REGEX "plat[-].*" EXCLUDE
              REGEX "wsgiref*" EXCLUDE
              REGEX "distutils/" EXCLUDE)
    endif(PARAVIEW_INSTALL_PYTHON)
  endif(PARAVIEW_ENABLE_PYTHON)

  set(DIRS) # directories to search for prerequisites

  if(PARAVIEW_BUILD_QT_GUI)
    list(APPEND DIRS ${QT_BINARY_DIR} ${QT_LIBRARY_DIR})
  endif(PARAVIEW_BUILD_QT_GUI)

  if(VTK_USE_FFMPEG_ENCODER)
    get_filename_component(FFMPEG_DIR "${FFMPEG_avcodec_LIBRARY}" PATH)
    list(APPEND DIRS ${FFMPEG_DIR})
  endif(VTK_USE_FFMPEG_ENCODER)

  if(PARAVIEW_ENABLE_PYTHON)
    get_filename_component(PYTHON_BIN_DIR "${PYTHON_EXECUTABLE}" PATH)
    get_filename_component(PYTHON_LIB_DIR "${PYTHON_LIBRARY}" PATH)
    list(APPEND DIRS ${PYTHON_BIN_DIR} ${PYTHON_LIB_DIR})
  endif(PARAVIEW_ENABLE_PYTHON)

  if(PARAVIEW_BUILD_PLUGIN_Manta)
    if(WIN32)
      list(APPEND DIRS ${MANTA_BUILD}/lib/${CMAKE_CFG_INTDIR})
    else()
      list(APPEND DIRS ${MANTA_BUILD}/lib)
    endif()
  endif(PARAVIEW_BUILD_PLUGIN_Manta)

  if(PARAVIEW_USE_MPI)
    get_filename_component(MPI_LIB_DIR "${MPI_LIBRARY}" PATH)
    get_filename_component(MPI_BIN_DIR "${MPIEXEC}" PATH)
    list(APPEND DIRS ${MPI_LIB_DIR} ${MPI_BIN_DIR})

    option(PARAVIEW_INSTALL_MPIEXEC "Include the MPI executable in an installation." OFF)
    mark_as_advanced(PARAVIEW_INSTALL_MPIEXEC)
    if(PARAVIEW_INSTALL_MPIEXEC AND MPIEXEC)
      GET_FILENAME_COMPONENT(mpi_bin_dir ${MPIEXEC} PATH)
      install(DIRECTORY ${mpi_bin_dir}/
        DESTINATION ${pv_runtime_dest}
        USE_SOURCE_PERMISSIONS
        COMPONENT Runtime
        PATTERN "mpicc*" EXCLUDE
        PATTERN "mpicxx*" EXCLUDE
        PATTERN "mpic++*" EXCLUDE
        PATTERN "python*" EXCLUDE)
    endif(PARAVIEW_INSTALL_MPIEXEC AND MPIEXEC)
  endif(PARAVIEW_USE_MPI)

  set(_dir "${PV_INSTALL_LIB_DIR}")
  if(WIN32)
    set(_dir "bin")
  endif(WIN32)

  if(NOT PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS)
    set(PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS ${DIRS} CACHE STRING
      "Directories for FixupBundle to search for dependencies" FORCE)
  endif()
  mark_as_advanced(PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS)
  
  set(search_path ${PARAVIEW_FIXUP_BUNDLE_SEARCH_PATHS})
  list(APPEND search_path ${DIRS})
  list(REMOVE_DUPLICATES search_path)

  set(APPS "\${CMAKE_INSTALL_PREFIX}/${_dir}/paraview${CMAKE_EXECUTABLE_SUFFIX}")  # paths to executables

  if(WIN32)
    foreach(pluginname ${PARAVIEW_PLUGINLIST})
      list(APPEND plugin_libs "${EXECUTABLE_OUTPUT_PATH}/Release/${pluginname}.dll")
    endforeach(pluginname ${PARAVIEW_PLUGINLIST})
  else()
    foreach(pluginname ${PARAVIEW_PLUGINLIST})
      list(APPEND plugin_libs "${EXECUTABLE_OUTPUT_PATH}/lib${pluginname}.so")
    endforeach(pluginname ${PARAVIEW_PLUGINLIST})
  endif()

  set(PARAVIEW_INSTALL_APPS ${APPS} CACHE INTERNAL "" FORCE)
  set(PARAVIEW_INSTALL_PLUGIN_LIBS ${plugin_libs} CACHE INTERNAL "" FORCE)
  set(PARAVIEW_INSTALL_LIBRARY_SEARCH_PATH ${search_path} CACHE INTERNAL "" FORCE)

endif(PARAVIEW_INSTALL_THIRD_PARTY_LIBRARIES AND NOT APPLE)

#------------------------------------------------------------------------
# Import site specific installation rules file, if any.
set (PARAVIEW_EXTRA_INSTALL_RULES_FILE "" CACHE FILEPATH 
  "Path to site-specific install rules for ParaView.")
mark_as_advanced(PARAVIEW_EXTRA_INSTALL_RULES_FILE)


foreach(rule_file ${PARAVIEW_EXTRA_INSTALL_RULES_FILE})
  if (EXISTS "${rule_file}")
    include("${rule_file}")
  endif (EXISTS "${rule_file}")
endforeach(rule_file ${PARAVIEW_EXTRA_INSTALL_RULES_FILE})


#------------------------------------------------------------------------
# Install the .plugins configuration file.
install(FILES "${EXECUTABLE_OUTPUT_PATH}/.plugins"
        DESTINATION ${PV_INSTALL_PLUGIN_DIR}
        COMPONENT BrandedRuntime)

# Call this last so the install script runs after the above targets are installed:
#
#if(APPLE)
#
#  option(PARAVIEW_BUILD_AS_APPLICATION_BUNDLE "Build ParaView as a Mac Application Bundle" ON)
#  if(PARAVIEW_BUILD_AS_APPLICATION_BUNDLE)
#    set (ParaView_BUNDLE_LOCATION "" CACHE STRING
#      "Subdirectory in which to place ParaView app inside a bundle.")

#    mark_as_advanced(ParaView_BUNDLE_LOCATION)

#    set(distributed_plugins ${PARAVIEW_PLUGINLIST})
#    set(PV_EXE_NAME "paraview")
#    set(OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT
#      "${CMAKE_CURRENT_BINARY_DIR}/ParaView_OSX_MakeStandAloneBundle.cmake")
#    set(OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT
#      "${CMAKE_CURRENT_BINARY_DIR}/ParaView_OSX_MakeStandAloneBundle.sh")
    
#    set (QT_SQLLITE_PLUGINS_DIR ${QT_PLUGINS_DIR}/sqldrivers)

#    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CompleteBundle.cmake.in"
#      "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}" @ONLY IMMEDIATE)
#    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CreateBundle.sh.in"
#      "${OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT}" @ONLY IMMEDIATE)

#    install(SCRIPT "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}" COMPONENT Bundle)
#  endif(PARAVIEW_BUILD_AS_APPLICATION_BUNDLE)
#endif(APPLE)

# Call FixupBundle in a subdirectory
add_subdirectory(LastConfigureStep)

set(_package_name "ParaView")
if(PARAVIEW_INSTALL_DEVELOPMENT)
  set(_package_name "ParaView-Development")
endif(PARAVIEW_INSTALL_DEVELOPMENT)

set(_paraview_version_patch_full "${PARAVIEW_VERSION_PATCH}")
if(NOT "${PARAVIEW_VERSION_PATCH_EXTRA}" STREQUAL "")
  set(_paraview_version_patch_full 
    "${PARAVIEW_VERSION_PATCH}-${PARAVIEW_VERSION_PATCH_EXTRA}"
  )
endif(NOT "${PARAVIEW_VERSION_PATCH_EXTRA}" STREQUAL "")

#------------------------------------------------------------------------
# Install ParaView client
build_paraview_client_cpack_config_init(
    PACKAGE_NAME ${_package_name}
    ORGANIZATION "Kitware Inc."
    VERSION_MAJOR "${PARAVIEW_VERSION_MAJOR}"
    VERSION_MINOR "${PARAVIEW_VERSION_MINOR}"
    VERSION_PATCH "${_paraview_version_patch_full}"
    DESCRIPTION "ParaView is a scientific visualization tool"
    LICENSE_FILE "${ParaView_SOURCE_DIR}/License_v1.2.txt"
    DESCRIPTION_FILE "${ParaView_SOURCE_DIR}/License_v1.2.txt"
    PACKAGE_EXECUTABLES "paraview;ParaView"
)

# Set NSIS specific CPACK vars for install icons, strings etc..
if(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.

=== debian/changelog ===
paraview (3.14.1-6) unstable; urgency=low

  * [6183021] Install ParaViewUse.cmake.
  * [d986588] Install *.xsl files into cmake-directory.

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 19 Jun 2012 21:08:22 +0200

paraview (3.14.1-5) unstable; urgency=low

  * [4b21168] Fix installation of cmake-files. (Closes: #677492)

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 16 Jun 2012 15:13:50 +0200

paraview (3.14.1-4) unstable; urgency=low

  * [4c779aa] Tough version of libqtwebkit-dev (>=2.2.1). (Closes: #672716)
  * [6e40327] Use compat-version 8.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 13 May 2012 22:57:04 +0200

paraview (3.14.1-3) unstable; urgency=low

  * [cfe1177] Fix FTBFS against gcc-4.7. (Closes: #672037)

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 08 May 2012 18:50:16 +0200

paraview (3.14.1-2) unstable; urgency=low

  * [c746c1f] Install usr/lib/paraview/pvpython. (Closes: #671753)
  * [d04f9a0] Fix FTBFS against boost 1.49.
  * [1558d81] Use libboost-all-dev instead of hardcoded 1.48 version.
  * [66163b1] Use Standards-Version: 3.9.3. No changes.

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 07 May 2012 19:12:52 +0200

paraview (3.14.1-1) unstable; urgency=low

  * [726d949] Imported Upstream version 3.14.1
  * [faf22f8] Use Standards-Version: 3.9.3, no changes.

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 07 Apr 2012 11:12:14 +0200

=== debian/control ===
Source: paraview
Section: science
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, 
 Mathieu Malaterre <mathieu.malaterre@gmail.com>, 
 Anton Gladky <gladky.anton@gmail.com>
Build-Depends: debhelper (>= 8), cmake (>= 2.6.3), 
 libqt4-dev (>= 4.3.3-2), libsqlite3-dev,
 qt4-dev-tools, libboost-all-dev, 
 libavformat-dev (>= 0.7.1),
 libavutil-dev, libavcodec-dev, libswscale-dev, python-dev, python-support, 
 libglu1-mesa-dev, libxt-dev, python-all, 
 python-all-dev (>= 2.7), python-all-dev (<< 2.8),
 libxext-dev, doxygen, graphviz, gnuplot, libtiff-dev, libpng-dev, libjpeg-dev,
 libxml2-dev, libexpat-dev,
 zlib1g-dev, libfreetype6-dev, libmysqlclient-dev, libpq-dev, libtheora-dev, 
 libogg-dev, mpi-default-dev, libhdf5-dev (>= 1.8.8), hdf5-tools,
 libgl2ps-dev, libqtwebkit-dev (>=2.2.1)
Standards-Version: 3.9.3
Homepage: http://www.paraview.org/
Vcs-Git: git://git.debian.org/git/debian-science/packages/paraview.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/paraview.git

Package: paraview
Architecture: any
Depends: qt4-dev-tools, tcl8.5 | tclsh, ${shlibs:Depends}, ${misc:Depends}
Suggests: hdf5-tools, h5utils
Recommends: mpi-default-bin, paraview-python, paraview-doc
Description: Parallel Visualization Application
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt.
 
Package: paraview-dev
Architecture: any
Section: libdevel
Depends: qt4-dev-tools, ${shlibs:Depends}, ${misc:Depends}, paraview (= ${binary:Version})
Recommends: qt4-dev-tools (>= 4.3.3-2)
Description: Parallel Visualization Application. Development header files
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Development header files

Package: paraview-doc
Architecture: all
Recommends: paraview
Section: doc
Depends: ${misc:Depends}
Description: Parallel Visualization Application. Comprehensive documentation
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Comprehensive documentation.

Package: paraview-python
Architecture: any
Section: python
Depends: paraview (= ${binary:Version}), ${python:Depends}, ${misc:Depends}, 
 ${shlibs:Depends}, python (>= 2.7), python (<<2.8), python-vtk
Provides: ${python:Provides}
Description: Parallel Visualization Application. python-support
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Enables python support.

=== debian/rules ===
#! /usr/bin/make -f
#export DH_VERBOSE=1

DESTDIR = $(CURDIR)/debian/tmp

%:
	dh $@ --with python2 --parallel

export LD_LIBRARY_PATH+=:$(CURDIR)/debian/paraview/usr/lib/paraview

# http://lists.alioth.debian.org/pipermail/debian-science-maintainers/2011-June/008157.html
# cmake will inspect those settings automatically:
export CFLAGS := -Wall $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

# CMAKE_SKIP_RPATH=OFF is important otherwise documentation generation will fails with:
# vtkSMExtractDocumentation: error while loading shared libraries: libvtkPVServerManager.so:
# No rule to make target `Documentation/ParaViewWriters.html', needed by `Documentation/paraview.qhp'.  Stop.

# Explicit settings of MPI_* is required see
# http://www.vtk.org/Bug/view.php?id=12572
PYVER = $(shell pyversions -dv)
extra_flags += -Wno-dev \
	-DPARAVIEW_GENERATE_PROXY_DOCUMENTATION=ON \
	-DCMAKE_INSTALL_RPATH=/usr/lib/paraview \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF  \
	-DCMAKE_SKIP_RPATH=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DPARAVIEW_INSTALL_THIRD_PARTY_LIBRARIES=OFF \
	-DBUILD_TESTING=OFF \
	-DVTK_USE_MPEG2_ENCODER=OFF \
	-DVTK_USE_FFMPEG_ENCODER=ON \
	-DFFMPEG_INCLUDE_DIR=/usr/include/libavcodec \
	-DPV_INSTALL_LIB_DIR="lib/paraview" \
	-DPV_INSTALL_INCLUDE_DIR="include/paraview" \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DBUILD_EXAMPLES=OFF \
	-DVTK_USE_GL2PS=ON \
	-DVTK_USE_BOOST=ON \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DDOCUMENTATION_HTML_HELP=ON \
	-DPARAVIEW_INSTALL_DEVELOPMENT=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DVTK_USE_MYSQL=ON \
	-DVTK_USE_POSTGRES=ON \
	-DVTK_USE_N_WAY_ARRAYS=ON \
	-DPARAVIEW_USE_MPI=ON \
	-DMPI_INCLUDE_PATH="/usr/include/mpi" \
	-DPARAVIEW_USE_SYSTEM_HDF5=ON \
	-DVTK_USE_SYSTEM_HDF5=ON \
	-DPARAVIEW_ENABLE_PYTHON=ON \
	-DVTK_USE_OGGTHEORA_ENCODER=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DPARAVIEW_BUILD_PLUGIN_AdiosReader:BOOL=ON \
	-DPARAVIEW_BUILD_PLUGIN_EyeDomeLighting:BOOL=ON \

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_compress:
	dh_compress -X.qch

override_dh_auto_install:
	dh_auto_install
	chmod a+x $(DESTDIR)/usr/lib/paraview/testing/FindString.tcl

override_dh_install:
	dh_install --list-missing
